#include <pgmspace.h>
#include "kb.h"
#include "serial.h"
#include "gpr.h"

#include "scancodes.h"

#define BUFF_SIZE 64

unsigned char edge, bitcount;				// 0=A1=

unsigned char kb_buffer[BUFF_SIZE];
unsigned char *inpt, *outpt;
unsigned char buffcnt;

void init_kb(void)
{
	inpt =  kb_buffer;						// ɏՕ
	outpt = kb_buffer;
	buffcnt = 0;

	MCUCR = 2;								// ~[INT0荞
	edge = 0;								// 0=~[A1㏸[
	bitcount = 11;
}

interrupt [INT0_vect] void INT0_interrupt (void)
{
	static unsigned char data;				// Mێ

	if (!edge)								// ~[ňڍsٰ
	{
		if(bitcount < 11 && bitcount > 2)	// ޯ3`10ްAè ޯāA
		{									// Jnƒ~ޯĂ͖܂B
			data = (data >> 1);
			if(PIND & 8)
				data = data | 0x80;			// '1'i[
		}

		MCUCR = 3;							// ㏸[ł̊荞݂ݒ
		edge = 1;

	} else {								// ㏸[ňڍsٰ

		MCUCR = 2;							// ~[ł̊荞݂ݒ
		edge = 0;

		if(--bitcount == 0)					// SޯĎM
		{
			decode(data);
			bitcount = 11;
		}
	}
}

void decode (unsigned char sc)
{
	static unsigned char is_up=0, shift = 0, mode = 0;
	unsigned char i;

	if (!is_up)								// ŌɎMްʎqB
	{
		switch (sc)
		{
			case 0xF0 :						// ʎq
				is_up = 1;
				break;

			case 0x12 :						// Shift
				shift = 1;
				break;

			case 0x59 :						// EShift
				shift = 1;
				break;

			case 0x05 :						// F1
				if(mode == 0)
					mode = 1;				// ֈڍs
				if(mode == 2)
					mode = 3;				// 씲o
				break;

			default:
				if(mode == 0 || mode == 3)	// ASCIIȂA
				{
					if(!shift)				// ShiftȂŁA
					{						// \Q
						for(i = 0; unshifted[i][0]!=sc && unshifted[i][0]; i++);
						if (unshifted[i][0] == sc) {
							put_kbbuff(unshifted[i][1]);
						}
					} else {				// ShiftŁA
						for(i = 0; shifted[i][0]!=sc && shifted[i][0]; i++);
						if (shifted[i][0] == sc) {
							put_kbbuff(shifted[i][1]);
						}
					}
				} else{						// 
					print_hexbyte(sc);		// Print
					put_kbbuff(' ');
					put_kbbuff(' ');
				}
				break;
		}
	} else {
		is_up = 0;							// 20xF0͋܂B
		switch (sc)
		{
			case 0x12 :						// Shift
				shift = 0;
				break;

			case 0x59 :						// EShift
				shift = 0;
				break;

			case 0x05 :						// F1
				if(mode == 1)
					mode = 2;
				if(mode == 3)
					mode = 0;
				break;
			case 0x06 :						// F2
				clr();
				break;
		}
	}
} 

void put_kbbuff (unsigned char c)
{
	if (buffcnt<BUFF_SIZE)					// ɏՕtłȂ΁A
	{
		*inpt = c;							// ɏՕɒuB
		inpt++;								// ʒuwq𑝉

		buffcnt++;

		if (inpt >= kb_buffer + BUFF_SIZE)	// ʒuwqۂ
			inpt = kb_buffer;
	}
}

int getchar (void)
{
	int byte;
	while(buffcnt == 0);					// ް҂

	byte = *outpt;							// ޲Ď擾
	outpt++;								// ʒuwq𑝉

	if (outpt >= kb_buffer + BUFF_SIZE)		// ʒuwqۂ
		outpt = kb_buffer;

	buffcnt--;								// ɏՕv팸

	return byte;
}
